from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Int, Directory, Float, String

Shovill_Se_V0_1_0 = CommandToolBuilder(tool="shovill_se", base_command=["shovill-se"], inputs=[ToolInput(tag="in_check", input_type=Boolean(optional=True), prefix="--check", doc=InputDocumentation(doc="Check dependencies are installed")), ToolInput(tag="in_se", input_type=Boolean(optional=True), prefix="--se", doc=InputDocumentation(doc="|single XXX Single-end reads (default: '')")), ToolInput(tag="in_depth", input_type=Int(optional=True), prefix="--depth", doc=InputDocumentation(doc="Sub-sample --R1/--R2 to this depth. Disable with --depth 0 (default: 150)")), ToolInput(tag="in_g_size", input_type=Int(optional=True), prefix="--gsize", doc=InputDocumentation(doc="Estimated genome size eg. 3.2M <blank=AUTODETECT> (default: '')")), ToolInput(tag="in_outdir", input_type=Directory(optional=True), prefix="--outdir", doc=InputDocumentation(doc="Output folder (default: '')")), ToolInput(tag="in_force", input_type=Directory(optional=True), prefix="--force", doc=InputDocumentation(doc="Force overwite of existing output folder (default: OFF)")), ToolInput(tag="in_min_len", input_type=Int(optional=True), prefix="--minlen", doc=InputDocumentation(doc="Minimum contig length <0=AUTO> (default: 0)")), ToolInput(tag="in_min_cov", input_type=Int(optional=True), prefix="--mincov", doc=InputDocumentation(doc="Minimum contig coverage <0=AUTO> (default: 2)")), ToolInput(tag="in_name_fmt", input_type=Int(optional=True), prefix="--namefmt", doc=InputDocumentation(doc="Format of contig FASTA IDs in 'printf' style (default: 'contig%05d')")), ToolInput(tag="in_keep_files", input_type=Boolean(optional=True), prefix="--keepfiles", doc=InputDocumentation(doc="Keep intermediate files (default: OFF)")), ToolInput(tag="in_tmpdir", input_type=Directory(optional=True), prefix="--tmpdir", doc=InputDocumentation(doc="Fast temporary directory (default: '')")), ToolInput(tag="in_cpus", input_type=Int(optional=True), prefix="--cpus", doc=InputDocumentation(doc="Number of CPUs to use (0=ALL) (default: 1)")), ToolInput(tag="in_ram", input_type=Float(optional=True), prefix="--ram", doc=InputDocumentation(doc="Try to keep RAM usage below this many GB (default: 15.64)")), ToolInput(tag="in_assembler", input_type=String(optional=True), prefix="--assembler", doc=InputDocumentation(doc="Assembler: spades velvet skesa megahit (default: 'spades')")), ToolInput(tag="in_opts", input_type=String(optional=True), prefix="--opts", doc=InputDocumentation(doc="Extra assembler options in quotes eg. spades: '--sc' ... (default: '')")), ToolInput(tag="in_km_ers", input_type=String(optional=True), prefix="--kmers", doc=InputDocumentation(doc="K-mers to use <blank=AUTO> (default: '')")), ToolInput(tag="in_trim", input_type=Boolean(optional=True), prefix="--trim", doc=InputDocumentation(doc="Enable adaptor trimming (default: OFF)")), ToolInput(tag="in_no_corr", input_type=Boolean(optional=True), prefix="--nocorr", doc=InputDocumentation(doc="Disable post-assembly correction (default: OFF)"))], outputs=[ToolOutput(tag="out_outdir", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_outdir", type_hint=File()), doc=OutputDocumentation(doc="Output folder (default: '')")), ToolOutput(tag="out_force", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_force", type_hint=File()), doc=OutputDocumentation(doc="Force overwite of existing output folder (default: OFF)"))], container="quay.io/biocontainers/shovill-se:1.1.0se--0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Shovill_Se_V0_1_0().translate("wdl")

